#! /usr/bin/perl
use strict;
use warnings;
use POSIX qw(:signal_h);
use Sys::SigAction qw(set_sig_handler);
use Parallel::Prefork;

my $pm = Parallel::Prefork->new(
    +{
        max_workers  => 5,
        trap_signals => +{
            TERM => 'TERM',
            HUP  => 'TERM',
            USR1 => undef,
        },
    }
);
my $max_requests_per_child = 50;
while ( $pm->signal_received ne 'TERM' ) {
    $pm->start and next;
    my $i = 0;
    my $is_stop=0;
    my $h = set_sig_handler(
        'TERM',
        sub {$is_stop = 1},
        +{flags => SA_RESTART}
    );
    while ( $i++ < $max_requests_per_child ) {
        # ここでワーカの処理を起動させる
        last if $is_stop;
    }
    $pm->finish;
}
$pm->wait_all_children;
